; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 656
WINDOWHEIGHT = 518
MAXOBJECTS   = 1000
ANTIALIASED_QUALITY = 4
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	visible:byte
local	rendered:dword
local	time_:dword
local	buff[10h]:dword

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN
        cmp	edx,WM_TIMER
	je      wmTIMER          
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	mov	ecx,base
	invoke	glDeleteLists,,96; Delete All 96 Characters
	mov	ecx,frustum
	invoke	GlobalFree
	mov	ecx,objects
	invoke	GlobalFree
	invoke	KillTimer,hWin,10
	invoke	RtlExitUserProcess,NULL
;------------------------------
wmTIMER:and     rendered,0
	inc	frame_; Increment Frame Counter
	invoke	GetTickCount; Get Timer Value
	mov	time_,eax
	sub	eax,timebase
	cvtsi2sd xmm1,eax
	cmp	eax,1000
	jb	@f;if( time - timebase >= 1000 ); Has a second passed since last FPS update?
	cvtsi2sd xmm0,frame_
	mulsd	xmm0,constd1000
	divsd	xmm0,xmm1
	movq	fps,xmm0;fps = frame * 1000.0f/(time - timebase); calculate new FPS
	mov	eax,time_
	mov	timebase,eax;timebase = time; Save current tick count
	and	frame_,0; Start counting frames from zero again
@@:	invoke	InvalidateRect,hWin,0,0
        jmp	wmBYE
wmKEYDOWN:mov	al,r8b;wParam

	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	cmp	al,VK_ADD
	jne	@f
	cmp	numobjects,MAXOBJECTS
	jnb	wmBYE
	inc	numobjects
	jmp	@0
@@:	cmp	al,VK_SUBTRACT
	jne	@f
	cmp	numobjects,1
	jna	wmBYE
	dec	numobjects
	jmp	@0
@@:	cmp	al,VK_UP
	jne	@f
	movss	xmm0,heading
	mulss	xmm0,piover180
	invoke	sinf
	mulss	xmm0,const0_25
	movss	xmm1,xpos
	subss	xmm1,xmm0
	movss	xpos,xmm1
	movss	xmm0,heading
	mulss	xmm0,piover180
	invoke	cosf
	mulss	xmm0,const0_25
	addss	xmm0,zpos
	movss	zpos,xmm0
	jmp	@0
@@:	cmp	al,VK_DOWN
	jne	@f
	movss	xmm0,heading
	mulss	xmm0,piover180
	invoke	sinf
	mulss	xmm0,const0_25
	addss	xmm0,xpos
	movss	xpos,xmm0
	movss	xmm0,heading
	mulss	xmm0,piover180
	invoke	cosf
	mulss	xmm0,const0_25
	movss	xmm1,zpos
	subss	xmm1,xmm0
	movss	zpos,xmm1
	jmp	@0
@@:	cmp	al,VK_LEFT
	jne	@f
	movss	xmm0,heading
	subss	xmm0,const1
;	xorps	xmm1,xmm1
;	comiss	xmm0,xmm1
;	jnb	@3
;	addss	xmm0,const360
@3:	movss	heading,xmm0
	jmp	@0
@@:	cmp	al,VK_RIGHT
	jne	@f
	movss	xmm0,heading
	addss	xmm0,const1
;	comiss	xmm0,const360
;	jna	@4
;	subss	xmm0,const360
@4:	movss	heading,xmm0
	jmp	@0
@@:	cmp	al,VK_U
	jne	@f
	movss	xmm0,tilt
	subss	xmm0,const1
	movss	tilt,xmm0
	jmp	@0
@@:	cmp	al,VK_D
	jne	@f
	movss	xmm0,tilt
	addss	xmm0,const1
	movss	tilt,xmm0
	jmp	@0
@@:	cmp	al,VK_W
	jne	@f
	movq	xmm0,fov
	addsd	xmm0,constd1
	movq	fov,xmm0
	invoke	glMatrixMode,GL_PROJECTION; Select the Projection matrix
	invoke	glLoadIdentity; Reset the Projection matrix
	movq	xmm3,constd50
	movq	xmm2,constd0_5
	cvtsi2sd xmm1,windowwidth
	cvtsi2sd xmm0,windowheight
	divsd	xmm1,xmm0
	movq	xmm0,fov
	invoke	gluPerspective; Recreate the frustum
	invoke	glMatrixMode,GL_MODELVIEW; Select the modelview matrix
	jmp	@0
@@:	cmp	al,VK_G
	jne	@f
	xor	grid,1
	jmp	@0
@@:	cmp	al,VK_C
	jne	@f
	xor	culling,1
	jmp	@0
@@:	cmp	al,VK_M
	jne	@f
	inc	mode
	cmp	mode,3
	jb	@0
	mov	mode,0
	jmp	@0
@@:	cmp	al,VK_T
	jne	wmBYE
	movq	xmm0,fov
	subsd	xmm0,constd1
	movq	fov,xmm0
	invoke	glMatrixMode,GL_PROJECTION; Select the Projection matrix
	invoke	glLoadIdentity; Reset the Projection matrix
	movq	xmm3,constd50
	movq	xmm2,constd0_5
	cvtsi2sd xmm1,windowwidth
	cvtsi2sd xmm0,windowheight
	divsd	xmm1,xmm0
	movq	xmm0,fov
	invoke	gluPerspective; Recreate the Frustum
	invoke	glMatrixMode,GL_MODELVIEW; Select the Modelview matrix
@0:	invoke	InvalidateRect,hWin,0,0
        jmp	wmBYE
;-----------------------------------------	
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
;-------------------------------------------------------------------------------
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,MAXOBJECTS*7*4
	mov	objects,eax
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,6*4*4
	mov	frustum,eax
;-------------------------------------------------------
	invoke	time,0
	invoke	srand,eax;srand( (unsigned)time(NULL) ); Seed the Random Number Generator
	mov	esi,objects
	xor	edi,edi;for( i = 0; i < MAXOBJECTS; i++ )// Create MAXOBJECTS Random Objects
@@:	invoke	rand
	cdq
	mov	ecx,200
	idiv	ecx
	cvtsi2ss xmm0,edx
	subss	xmm0,const100 
	movss	dword ptr [rsi+rdi],xmm0;objects[i][0] = -100.0f + rand() % 200; Random X From -100 To 100
	invoke	rand
	cdq
	mov	ecx,20
	idiv	ecx
	cvtsi2ss xmm0,edx
	subss	xmm0,const10 
	movss	dword ptr [rsi+rdi + 1*4],xmm0;objects[i][1] = -10.0f + rand() % 20; Random Y From -10 To 10
	invoke	rand
	cdq
	mov	ecx,200
	idiv	ecx
	cvtsi2ss xmm0,edx
	subss	xmm0,const100
	movss	dword ptr [rsi+rdi + 2*4],xmm0;objects[i][2] = -100.0f + rand() % 200; Random Z From -100 To 100
	invoke	rand
	cdq
	mov	ecx,5
	idiv	ecx
	inc	edx
	cvtsi2ss xmm0,edx
	mulss	xmm0,const0_5 
	movss	dword ptr [rsi+rdi + 3*4],xmm0;objects[i][3] = 0.5f * (1 + rand() % 5); Random Size/Radius From 0.5 to 3
	invoke	rand
	cdq
	mov	ecx,100
	idiv	ecx
	cvtsi2ss xmm0,edx
	mulss	xmm0,const0_01 
	movss	dword ptr [rsi+rdi + 4*4],xmm0;objects[i][4] = .01f * (rand() % 100); Random RED Value
	invoke	rand
	cdq
	mov	ecx,100
	idiv	ecx
	cvtsi2ss xmm0,edx
	mulss	xmm0,const0_01 
	movss	dword ptr [rsi+rdi + 5*4],xmm0;objects[i][5] = .01f * (rand() % 100); Random GREEN Value
	invoke	rand
	cdq
	mov	ecx,100
	idiv	ecx
	cvtsi2ss xmm0,edx
	mulss	xmm0,const0_01 
	movss	dword ptr [rsi+rdi + 6*4],xmm0;objects[i][6] = .01f * (rand() % 100); Random BLUE Value
	add	edi,7*4
	cmp	edi,MAXOBJECTS*7*4
	jb	@b

	invoke	BuildFont; Build A Bitmap Font
	invoke	glShadeModel,GL_SMOOTH; Enable Smooth Shading
	movss	xmm3,const1
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor;0, 0, 0, 1.0 Black Background
	movq	xmm0,constd1
	invoke	glClearDepth; Depth Buffer Setup
	invoke	glEnable,GL_DEPTH_TEST; Enables Depth Testing
	invoke	glDepthFunc,GL_LEQUAL; the Type Of Depth Testing To Do
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST; Really Nice Perspective Calculations
	mov	r8d,offset LightAmbient
	invoke	glLightfv,GL_LIGHT1, GL_AMBIENT; Set Up Ambient Lighting
	mov	r8d,offset LightDiffuse
	invoke	glLightfv,GL_LIGHT1, GL_DIFFUSE; Set Up Diffuse Lighting
	invoke	glEnable,GL_LIGHT1; Enable Light #1
	invoke	glEnable,GL_LIGHTING; Turn On Lighting
	invoke	glEnable,GL_COLOR_MATERIAL; Enable Tracking the Color Parameter
	invoke	glColorMaterial,GL_FRONT, GL_AMBIENT_AND_DIFFUSE; Make Ambient And Diffuse Track Color
        invoke	SetTimer,hWin,10,25,0;  #10  25mSec
        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	mov	windowwidth,r8d; Save Width In Global
	shr	r9d,16
	mov	h,r9d
	mov	windowheight,r9d; Save Height In Global
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd50
	movq	xmm2,constd0_5
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,fov
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke  BeginPaint
; --------------- Display the scene
	mov	esi,objects
	mov	rendered,0
        invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT; Clear Screen And Depth Buffer
        invoke	glLoadIdentity; Reset the current modelview matrix
        xorps	xmm3,xmm3
        xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,tilt
        invoke	glRotatef;  Tilt camera
        xorps	xmm3,xmm3
	movss	xmm2,const1
        xorps	xmm1,xmm1
	movss	xmm0,heading
        invoke	glRotatef; Point camera towards heading
	movss	xmm2,zpos
	movss	xmm1,const_2
	movss	xmm0,xpos
        invoke	glTranslatef;  Translate to camera position
	mov	r8d,offset LightPosition
        invoke	glLightfv,GL_LIGHT1, GL_POSITION; Set Up Light Position

        invoke	ExtractFrustum; Extract the Frustum Plane Equations

	cmp	grid,0
	jz	@2
        invoke	glPushMatrix; Save the current MODELVIEW matrix
	movss	xmm2,const0_6
	movss	xmm1,xmm2
	movss	xmm0,xmm2
        invoke	glColor3f;   draw grid in GRAY
        invoke	glBegin,GL_LINES; Begin drawing lines for a grid
	mov	edi,-100; draw 200 lines in one direction
@@:     mov	r8d,-100
	invoke	glVertex3i,edi,0
	mov	r8d,100
        invoke	glVertex3i,edi,0
	inc	edi
	cmp	edi,100
	jle	@b

	mov	edi,-100; and 200 lines across the others
@@:	mov	ecx,-100
	invoke	glVertex3i,,0,edi
	mov	ecx,100
	invoke	glVertex3i,,0,edi
	inc	edi
	cmp	edi,100
	jle	@b
	invoke	glEnd
	invoke	glPopMatrix; restore the current MODELVIEW matrix
@2:

	xor	edi,edi; draw up to 'numobjects' objects
@5:	cmp	culling,0; cull objects if culling is on
	jz	@6
	mov	eax,mode
	jmp	Labels1[rax*8]
Points1:movss	xmm3,const0_1
	jmp	@f
Spheres1:movss	xmm3,dword ptr [rsi+rdi+4*3]
@@:	movss	xmm2,dword ptr [rsi+rdi+4*2]
	movss	xmm1,dword ptr [rsi+rdi+4*1]
	movss	xmm0,dword ptr [rsi+rdi+4*0]
	invoke	SphereInFrustum
	mov	visible,al
	jmp	@7
Cubes1:	movss	xmm3,dword ptr [rsi+rdi+4*3]
	movss	xmm2,dword ptr [rsi+rdi+4*2]
	movss	xmm1,dword ptr [rsi+rdi+4*1]
	movss	xmm0,dword ptr [rsi+rdi+4*0]
	invoke	CubeInFrustum
	mov	visible,al
	jmp	@7
@6:	mov	visible,TRUE;	 if not culling, objects are visible
@7:     cmp	visible,0
	jz	@8
        invoke	glPushMatrix;	 Save the current MODELVIEW matrix
	movss	xmm2,dword ptr [rsi+rdi+4*2]
	movss	xmm1,dword ptr [rsi+rdi+4*1]
	movss	xmm0,dword ptr [rsi+rdi+4*0]
        invoke	glTranslatef
	movss	xmm2,dword ptr [rsi+rdi+4*6]
	movss	xmm1,dword ptr [rsi+rdi+4*5]
	movss	xmm0,dword ptr [rsi+rdi+4*4]
	mov	eax,mode
	jmp	Labels2[rax*8]
Points2:movss	xmm2,const1; Are We In Point Mode?
	movss	xmm1,xmm2
	movss	xmm0,xmm2
        invoke	glColor3f;  Draw Points In White
	movsd xmm0,constd0_1
	jmp	@f
; Are We In Sphere Mode?
Spheres2:invoke	glColor3f;  Set Drawing Color
	cvtss2sd xmm0,dword ptr [rsi+rdi+4*3]
@@:	invoke	glutSolidSphere,,32,32; Draw A Sphere
        invoke	glPopMatrix; Restore the current MODELVIEW matrix
	jmp	@8
Cubes2:	invoke	glColor3f;  Set Drawing Color
	cvtss2sd xmm0,dword ptr [rsi+rdi+4*3]
	addsd	xmm0,xmm0	; objects[i][3] * 2 
        invoke	glutSolidCube; Draw the Cube
        invoke	glPopMatrix; Restore the current MODELVIEW matrix
@8:	inc	rendered; Count How Many We Actually Draw
	add	edi,7*4
	imul	eax,numobjects,7*4
	cmp	edi,eax
	jb	@5


        invoke	ortho; Enter Orthographic Mode

	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
        invoke	glColor3f; 1.0, 1.0, 1.0; Set Color To White
	lea	r9,fps
	mov	r8d,offset Title0
	movss	xmm1,const10
	movss	xmm0,const1
	invoke	glPrint;( 1, 10, "FPS     : %0.1f", fps );	// Display current FPS

	lea	r9d,fov
	mov	r8d,offset Title1
	movss	xmm1,const20
	movss	xmm0,const1
	invoke	glPrint; 1, 20, "FOV     : %0.1f", fov  );	// Display current FOV
	lea	r9d,numobjects
	mov	eax,mode
	mov	r8d,TitleName1[rax*4]
	movss	xmm1,const30
	movss	xmm0,const1
        invoke	glPrint; mode == 0 ? "Points  " : (mode == 1 ? "Spheres " : "Cubes   "), numobjects  ); Display Total Number Of Objects
	lea	r9d,rendered
	mov	r8d,offset Title5
	movss	xmm1,const40
	movss	xmm0,const1
        invoke	glPrint;  Display Number Of Objects Actually Drawn
	xor	eax,eax
	mov	al,culling
	mov	r8d,TitleName2[rax*4]
	movss	xmm1,const50
	movss	xmm0,const1
	invoke	glPrint; 1, 50, "Culling : %s", culling ? "On" : "Off" );	// Display Culling State

        invoke	perspective; Return To Perspective Mode

;   
	invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke	EndPaint,hWin
wmBYE:	leave
	retn	
Labels1	dq Points1,Spheres1,Cubes1
Labels2	dq Points2,Spheres2,Cubes2
WndProc	endp
ortho proc dummy:dword
	invoke	glDisable,GL_DEPTH_TEST; Disable Depth Testing (All Text On Top!)
	invoke	glDisable,GL_LIGHTING; Disable Lighting
	invoke	glMatrixMode,GL_PROJECTION; Save the current PROJECTION matrix
	invoke	glPushMatrix
	invoke	glLoadIdentity
	xorps	xmm3,xmm3
	cvtsi2sd xmm2,windowheight
	cvtsi2sd xmm1,windowwidth
	xorps	xmm0,xmm0
	invoke	glOrtho,,,,,constd_1,constd1;	// Enter Orthographic Mode
	invoke	glMatrixMode,GL_MODELVIEW; Save the MODELVIEW matrix
	invoke	glPushMatrix
	invoke	glLoadIdentity
	leave
	ret
ortho endp
perspective proc dummy:dword
	invoke	glMatrixMode,GL_PROJECTION; Restore the PROJECTION matrix
	invoke	glPopMatrix
	invoke	glMatrixMode,GL_MODELVIEW; Restore the MODELVIEW matrix
	invoke	glPopMatrix
	invoke	glEnable,GL_DEPTH_TEST; Enable Depth Testing
	invoke	glEnable,GL_LIGHTING; Enable Lighting
	leave
	ret
perspective endp

SphereInFrustum proc  x:dword,y:dword,z:dword,radius:dword
	movss	x,xmm0
	movss	y,xmm1
	movss	z,xmm2
	movss	radius,xmm0

	xorps	xmm2,xmm2
	subss	xmm2,radius

	push	rdi
	push	rsi
	mov	esi,frustum
	xor	edi,edi
@@:	movss	xmm0,dword ptr [rsi+rdi+0*4]
	mulss	xmm0,x
	movss	xmm1,dword ptr [rsi+rdi+1*4]
	mulss	xmm1,y
	addss	xmm0,xmm1
	movss	xmm1,dword ptr [rsi+rdi+2*4]
	mulss	xmm1,z
	addss	xmm0,xmm1
	addss	xmm0,dword ptr [rsi+rdi+3*4]
	comiss	xmm0,xmm2
	jb	@f
	add	edi,4*4
	cmp	edi,6*4*4
	jb	@b
@@:	setnb	al
	pop	rsi
	pop	rdi
	leave
	ret
SphereInFrustum endp
CubeInFrustum proc  x:dword,y:dword,z:dword,size_:dword
	movss	x,xmm0
	movss	y,xmm1
	movss	z,xmm2
	movss	size_,xmm3
	xorps	xmm2,xmm2
	push	rdi
	push	rsi
	mov	esi,frustum
	xor	edi,edi
@0:	movss	xmm0,dword ptr [rsi+rdi+0*4]
	movss	xmm3,x
	subss	xmm3,size_
	mulss	xmm0,xmm3
	movss	xmm1,dword ptr [rsi+rdi+1*4]
	movss	xmm3,y
	subss	xmm3,size_
	mulss	xmm0,xmm3
	addss	xmm0,xmm1
	movss	xmm1,dword ptr [rsi+rdi+2*4]
	movss	xmm3,z
	subss	xmm3,size_
	mulss	xmm0,xmm3
	addss	xmm0,xmm1
	addss	xmm0,dword ptr [rsi+rdi+3*4]
	comiss	xmm0,xmm2;if(frustum[p][0]*(x-size)+frustum[p][1]*(y-size)+frustum[p][2]*(z-size)+frustum[p][3] > 0 )
	jna	@1
	movss	xmm0,dword ptr [rsi+rdi+0*4]
	movss	xmm3,x
	addss	xmm3,size_
	mulss	xmm0,xmm3
	movss	xmm1,dword ptr [rsi+rdi+1*4]
	movss	xmm3,y
	subss	xmm3,size_
	mulss	xmm0,xmm3
	addss	xmm0,xmm1
	movss	xmm1,dword ptr [rsi+rdi+2*4]
	movss	xmm3,z
	subss	xmm3,size_
	mulss	xmm0,xmm3
	addss	xmm0,xmm1
	addss	xmm0,dword ptr [rsi+rdi+3*4]
	comiss	xmm0,xmm2;if( frustum[p][0] * (x + size) + frustum[p][1] * (y - size) + frustum[p][2] * (z - size) + frustum[p][3] > 0 )
	jna	@1
	movss	xmm0,dword ptr [rsi+rdi+0*4]
	movss	xmm3,x
	subss	xmm3,size_
	mulss	xmm0,xmm3
	movss	xmm1,dword ptr [rsi+rdi+1*4]
	movss	xmm3,y
	addss	xmm3,size_
	mulss	xmm0,xmm3
	addss	xmm0,xmm1
	movss	xmm1,dword ptr [rsi+rdi+2*4]
	movss	xmm3,z
	subss	xmm3,size_
	mulss	xmm0,xmm3
	addss	xmm0,xmm1
	addss	xmm0,dword ptr [rsi+rdi+3*4]
	comiss	xmm0,xmm2
	jna	@1;if( frustum[p][0] * (x - size) + frustum[p][1] * (y + size) + frustum[p][2] * (z - size) + frustum[p][3] > 0 )
	movss	xmm0,dword ptr [rsi+rdi+0*4]
	movss	xmm3,x
	addss	xmm3,size_
	mulss	xmm0,xmm3
	movss	xmm1,dword ptr [rsi+rdi+1*4]
	movss	xmm3,y
	addss	xmm3,size_
	mulss	xmm0,xmm3
	addss	xmm0,xmm1
	movss	xmm1,dword ptr [rsi+rdi+2*4]
	movss	xmm3,z
	subss	xmm3,size_
	mulss	xmm0,xmm3
	addss	xmm0,xmm1
	addss	xmm0,dword ptr [rsi+rdi+3*4]
	comiss	xmm0,xmm2
	jna	@1;if( frustum[p][0] * (x + size) + frustum[p][1] * (y + size) + frustum[p][2] * (z - size) + frustum[p][3] > 0 )
	movss	xmm0,dword ptr [rsi+rdi+0*4]
	movss	xmm3,x
	subss	xmm3,size_
	mulss	xmm0,xmm3
	movss	xmm1,dword ptr [rsi+rdi+1*4]
	movss	xmm3,y
	subss	xmm3,size_
	mulss	xmm0,xmm3
	addss	xmm0,xmm1
	movss	xmm1,dword ptr [rsi+rdi+2*4]
	movss	xmm3,z
	addss	xmm3,size_
	mulss	xmm0,xmm3
	addss	xmm0,xmm1
	addss	xmm0,dword ptr [rsi+rdi+3*4]
	comiss	xmm0,xmm2
	jna	@1;if( frustum[p][0] * (x - size) + frustum[p][1] * (y - size) + frustum[p][2] * (z + size) + frustum[p][3] > 0 )
	movss	xmm0,dword ptr [rsi+rdi+0*4]
	movss	xmm3,x
	addss	xmm3,size_
	mulss	xmm0,xmm3
	movss	xmm1,dword ptr [rsi+rdi+1*4]
	movss	xmm3,y
	subss	xmm3,size_
	mulss	xmm0,xmm3
	addss	xmm0,xmm1
	movss	xmm1,dword ptr [rsi+rdi+2*4]
	movss	xmm3,z
	addss	xmm3,size_
	mulss	xmm0,xmm3
	addss	xmm0,xmm1
	addss	xmm0,dword ptr [rsi+rdi+3*4]
	comiss	xmm0,xmm2
	jna	@1;if( frustum[p][0] * (x + size) + frustum[p][1] * (y - size) + frustum[p][2] * (z + size) + frustum[p][3] > 0 )
	movss	xmm0,dword ptr [rsi+rdi+0*4]
	movss	xmm3,x
	subss	xmm3,size_
	mulss	xmm0,xmm3
	movss	xmm1,dword ptr [rsi+rdi+1*4]
	movss	xmm3,y
	addss	xmm3,size_
	mulss	xmm0,xmm3
	addss	xmm0,xmm1
	movss	xmm1,dword ptr [rsi+rdi+2*4]
	movss	xmm3,z
	addss	xmm3,size_
	mulss	xmm0,xmm3
	addss	xmm0,xmm1
	addss	xmm0,dword ptr [rsi+rdi+3*4]
	comiss	xmm0,xmm2
	jna	@1;if( frustum[p][0] * (x - size) + frustum[p][1] * (y + size) + frustum[p][2] * (z + size) + frustum[p][3] > 0 )
	movss	xmm0,dword ptr [rsi+rdi+0*4]
	movss	xmm3,x
	addss	xmm3,size_
	mulss	xmm0,xmm3
	movss	xmm1,dword ptr [rsi+rdi+1*4]
	movss	xmm3,y
	addss	xmm3,size_
	mulss	xmm0,xmm3
	addss	xmm0,xmm1
	movss	xmm1,dword ptr [rsi+rdi+2*4]
	movss	xmm3,z
	addss	xmm3,size_
	mulss	xmm0,xmm3
	addss	xmm0,xmm1
	addss	xmm0,dword ptr [rsi+rdi+3*4]
	comiss	xmm0,xmm2
	jna	@f
@1:	add	edi,4*4
	cmp	edi,6*4*4
	jb	@0
@@:	setnb	al
	pop	rsi
	pop	rdi
	leave
	ret
CubeInFrustum endp
ExtractFrustum proc
local	proj[16]:dword;	 For Grabbing the PROJECTION matrix
local	modl[16]:dword; For Grabbing the MODELVIEW matrix
local	clip[16]:dword; Result Of Concatenating PROJECTION and MODELVIEW
local	t:dword; Temporary Work Variable
	
	lea	edx, proj
	invoke	glGetFloatv,GL_PROJECTION_MATRIX; Grab the current PROJECTION matrix
	lea	edx,modl
	invoke	glGetFloatv,GL_MODELVIEW_MATRIX; Grab the current MODELVIEW matrix
	push	rsi
	mov	esi,frustum
; Concatenate (Multiply) the Two Matricies
	movss	xmm0,modl[0*4]
	mulss	xmm0,proj[0*4]
	movss	xmm1,modl[1*4]
	mulss	xmm1,proj[4*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[2*4]
	mulss	xmm1,proj[8*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[3*4]
	mulss	xmm1,proj[12*4]
	addss	xmm0,xmm1
	movss	clip[0*4],xmm0;clip[0]=modl[0]*proj[0]+modl[1]*proj[4]+modl[2]*proj[8]+modl[3]*proj[12]
	movss	xmm0,modl[0*4]
	mulss	xmm0,proj[1*4]
	movss	xmm1,modl[1*4]
	mulss	xmm1,proj[5*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[2*4]
	mulss	xmm1,proj[9*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[3*4]
	mulss	xmm1,proj[13*4]
	addss	xmm0,xmm1
	movss	clip[1*4],xmm0;clip[1]=modl[0]*proj[1]+modl[1]*proj[5]+modl[2]*proj[9]+modl[3]*proj[13]
	movss	xmm0,modl[0*4]
	mulss	xmm0,proj[2*4]
	movss	xmm1,modl[1*4]
	mulss	xmm1,proj[6*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[2*4]
	mulss	xmm1,proj[10*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[3*4]
	mulss	xmm1,proj[14*4]
	addss	xmm0,xmm1
	movss	clip[2*4],xmm0;clip[2]=modl[0]*proj[2]+modl[1]*proj[6]+modl[2]*proj[10]+modl[3]*proj[14]
       	movss	xmm0,modl[0*4]
	mulss	xmm0,proj[3*4]
	movss	xmm1,modl[1*4]
	mulss	xmm1,proj[7*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[2*4]
	mulss	xmm1,proj[11*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[3*4]
	mulss	xmm1,proj[15*4]
	addss	xmm0,xmm1
	movss	clip[3*4],xmm0;clip[3]=modl[0]*proj[3]+modl[1]*proj[7]+modl[2]*proj[11]+modl[3]*proj[15]
	movss	xmm0,modl[4*4]
	mulss	xmm0,proj[0*4]
	movss	xmm1,modl[5*4]
	mulss	xmm1,proj[4*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[6*4]
	mulss	xmm1,proj[8*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[7*4]
	mulss	xmm1,proj[12*4]
	addss	xmm0,xmm1
	movss	clip[4*4],xmm0;clip[4]=modl[4]*proj[0]+modl[5]*proj[4]+modl[6]*proj[8]+modl[7]*proj[12]
	movss	xmm0,modl[4*4]
	mulss	xmm0,proj[1*4]
	movss	xmm1,modl[5*4]
	mulss	xmm1,proj[5*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[6*4]
	mulss	xmm1,proj[9*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[7*4]
	mulss	xmm1,proj[13*4]
	addss	xmm0,xmm1
	movss	clip[5*4],xmm0;clip[5]=modl[4]*proj[1]+modl[5]*proj[5]+modl[6]*proj[9]+modl[7]*proj[13]
	movss	xmm0,modl[4*4]
	mulss	xmm0,proj[2*4]
	movss	xmm1,modl[5*4]
	mulss	xmm1,proj[6*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[6*4]
	mulss	xmm1,proj[10*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[7*4]
	mulss	xmm1,proj[14*4]
	addss	xmm0,xmm1
	movss	clip[6*4],xmm0;clip[6]=modl[4]*proj[2]+modl[5]*proj[6]+modl[6]*proj[10]+modl[7]*proj[14]
	movss	xmm0,modl[4*4]
	mulss	xmm0,proj[3*4]
	movss	xmm1,modl[5*4]
	mulss	xmm1,proj[7*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[6*4]
	mulss	xmm1,proj[11*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[7*4]
	mulss	xmm1,proj[15*4]
	addss	xmm0,xmm1
	movss	clip[7*4],xmm0;clip[7]=modl[4]*proj[3]+modl[5]*proj[7]+modl[6]*proj[11]+modl[7]*proj[15];

	movss	xmm0,modl[8*4]
	mulss	xmm0,proj[0*4]
	movss	xmm1,modl[9*4]
	mulss	xmm1,proj[4*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[10*4]
	mulss	xmm1,proj[8*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[11*4]
	mulss	xmm1,proj[12*4]
	addss	xmm0,xmm1
	movss	clip[8*4],xmm0;clip[8]=modl[8]* proj[0]+modl[9]*proj[4]+modl[10]*proj[8]+modl[11]*proj[12]
	movss	xmm0,modl[8*4]
	mulss	xmm0,proj[1*4]
	movss	xmm1,modl[9*4]
	mulss	xmm1,proj[5*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[10*4]
	mulss	xmm1,proj[9*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[11*4]
	mulss	xmm1,proj[13*4]
	addss	xmm0,xmm1
	movss	clip[9*4],xmm0;clip[9]=modl[8]*proj[1]+modl[9]*proj[5]+modl[10]*proj[9]+modl[11]*proj[13]
	movss	xmm0,modl[8*4]
	mulss	xmm0,proj[2*4]
	movss	xmm1,modl[9*4]
	mulss	xmm1,proj[6*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[10*4]
	mulss	xmm1,proj[10*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[11*4]
	mulss	xmm1,proj[14*4]
	addss	xmm0,xmm1
	movss	clip[10*4],xmm0;clip[10]=modl[8]*proj[2]+modl[9]*proj[6]+modl[10]*proj[10]+modl[11]*proj[14];
	movss	xmm0,modl[8*4]
	mulss	xmm0,proj[3*4]
	movss	xmm1,modl[9*4]
	mulss	xmm1,proj[7*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[10*4]
	mulss	xmm1,proj[11*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[11*4]
	mulss	xmm1,proj[15*4]
	addss	xmm0,xmm1
	movss	clip[11*4],xmm0;clip[11]=modl[8]*proj[3]+modl[9]*proj[7]+modl[10]*proj[11]+modl[11]*proj[15]

	movss	xmm0,modl[12*4]
	mulss	xmm0,proj[0*4]
	movss	xmm1,modl[13*4]
	mulss	xmm1,proj[4*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[14*4]
	mulss	xmm1,proj[8*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[15*4]
	mulss	xmm1,proj[12*4]
	addss	xmm0,xmm1
	movss	clip[12*4],xmm0;clip[12]=modl[12]*proj[0]+modl[13]*proj[4]+modl[14]*proj[8]+modl[15]*proj[12]
	movss	xmm0,modl[12*4]
	mulss	xmm0,proj[1*4]
	movss	xmm1,modl[13*4]
	mulss	xmm1,proj[5*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[14*4]
	mulss	xmm1,proj[9*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[15*4]
	mulss	xmm1,proj[13*4]
	addss	xmm0,xmm1
	movss	clip[13*4],xmm0;clip[13]=modl[12]*proj[1]+modl[13]*proj[5]+modl[14]*proj[9]+modl[15]*proj[13];
	movss	xmm0,modl[12*4]
	mulss	xmm0,proj[2*4]
	movss	xmm1,modl[13*4]
	mulss	xmm1,proj[6*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[14*4]
	mulss	xmm1,proj[10*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[15*4]
	mulss	xmm1,proj[14*4]
	addss	xmm0,xmm1
	movss	clip[14*4],xmm0;clip[14]=modl[12]*proj[2]+modl[13]*proj[6]+modl[14]*proj[10]+modl[15]*proj[14]
	movss	xmm0,modl[12*4]
	mulss	xmm0,proj[3*4]
	movss	xmm1,modl[13*4]
	mulss	xmm1,proj[7*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[14*4]
	mulss	xmm1,proj[11*4]
	addss	xmm0,xmm1
	movss	xmm1,modl[15*4]
	mulss	xmm1,proj[15*4]
	addss	xmm0,xmm1
	movss	clip[15*4],xmm0;clip[15]=modl[12]*proj[3]+modl[13]*proj[7]+modl[14]*proj[11]+modl[15]*proj[15]


; Extract the RIGHT clipping plane
	movss	xmm0,clip[3*4]
	subss	xmm0,clip[0*4]
	movss   dword ptr [rsi+0*16][0*4],xmm0;frustum[0][0] = clip[ 3] - clip[ 0];
	movss	xmm0,clip[7*4]
	subss	xmm0,clip[4*4]
	movss   dword ptr [rsi+0*16][1*4],xmm0;frustum[0][1] = clip[ 7] - clip[ 4];
	movss	xmm0,clip[11*4]
	subss	xmm0,clip[8*4]
	movss   dword ptr [rsi+0*16][2*4],xmm0;frustum[0][2] = clip[11] - clip[ 8];
	movss	xmm0,clip[15*4]
	subss	xmm0,clip[12*4]
	movss   dword ptr [rsi+0*16][3*4],xmm0;frustum[0][3] = clip[15] - clip[12];

; Normalize it
	movss	xmm0,dword ptr [rsi+16*0][4*0]
	mulss	xmm0,xmm0
	movss	xmm1,dword ptr [rsi+16*0][4*1]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	movss	xmm1,dword ptr [rsi+16*0][4*2]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	sqrtss	xmm0,xmm0
	movss	t,xmm0;t=(float)sqrt(frustum[0][0]*frustum[0][0]+frustum[0][1]*frustum[0][1]+frustum[0][2]*frustum[0][2])
	movss	xmm0,dword ptr [rsi+16*0][4*0]
	divss	xmm0,t
	movss	dword ptr [rsi+16*0][4*0],xmm0;frustum[0][0] /= t;
	movss	xmm0,dword ptr [rsi+16*0][4*1]
	divss	xmm0,t
	movss	dword ptr [rsi+16*0][4*1],xmm0;frustum[0][1] /= t;
	movss	xmm0,dword ptr [rsi+16*0][4*2]
	divss	xmm0,t
	movss	dword ptr [rsi+16*0][4*2],xmm0;frustum[0][2] /= t;
	movss	xmm0,dword ptr [rsi+16*0][4*3]
	divss	xmm0,t
	movss	dword ptr [rsi+16*0][4*3],xmm0;frustum[0][3] /= t;


; Extract the LEFT clipping plane
	movss	xmm0,clip[3*4]
	addss	xmm0,clip[0*4]
	movss   dword ptr [rsi+1*16][0*4],xmm0;frustum[1][0] = clip[ 3] + clip[ 0];
	movss	xmm0,clip[7*4]
	addss	xmm0,clip[4*4]
	movss   dword ptr [rsi+1*16][1*4],xmm0;frustum[1][1] = clip[ 7] + clip[ 4];
	movss	xmm0,clip[11*4]
	addss	xmm0,clip[8*4]
	movss   dword ptr [rsi+1*16][2*4],xmm0;frustum[1][2] = clip[11] + clip[ 8];
	movss	xmm0,clip[15*4]
	addss	xmm0,clip[12*4]
	movss   dword ptr [rsi+1*16][3*4],xmm0;frustum[1][3] = clip[15] + clip[12];

; Normalize it
	movss	xmm0,dword ptr [rsi+16*1][4*0]
	mulss	xmm0,xmm0
	movss	xmm1,dword ptr [rsi+16*1][4*1]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	movss	xmm1,dword ptr [rsi+16*1][4*2]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	sqrtss	xmm0,xmm0
	movss	t,xmm0;t=(float)sqrt(frustum[1][0]*frustum[1][0]+frustum[1][1]*frustum[1][1]+frustum[1][2]*frustum[1][2])
	movss	xmm0,dword ptr [rsi+16*1][4*0]
	divss	xmm0,t
	movss	dword ptr [rsi+16*1][4*0],xmm0;frustum[1][0] /= t;
	movss	xmm0,dword ptr [rsi+16*1][4*1]
	divss	xmm0,t
	movss	dword ptr [rsi+16*1][4*1],xmm0;frustum[1][1] /= t;
	movss	xmm0,dword ptr [rsi+16*1][4*2]
	divss	xmm0,t
	movss	dword ptr [rsi+16*1][4*2],xmm0;frustum[1][2] /= t;
	movss	xmm0,dword ptr [rsi+16*1][4*3]
	divss	xmm0,t
	movss	dword ptr [rsi+16*1][4*3],xmm0;frustum[1][3] /= t;


; Extract the BOTTOM clipping plane
	movss	xmm0,clip[3*4]
	addss	xmm0,clip[1*4]
	movss   dword ptr [rsi+2*16][0*4],xmm0;frustum[2][0] = clip[ 3] + clip[ 1];

	movss	xmm0,clip[7*4]
	addss	xmm0,clip[5*4]
	movss   dword ptr [rsi+2*16][1*4],xmm0;frustum[2][1] = clip[ 7] + clip[ 5];

	movss	xmm0,clip[11*4]
	addss	xmm0,clip[9*4]
	movss   dword ptr [rsi+2*16][2*4],xmm0;frustum[2][2] = clip[11] + clip[ 9];

	movss	xmm0,clip[15*4]
	addss	xmm0,clip[13*4]
	movss   dword ptr [rsi+2*16][3*4],xmm0;frustum[2][3] = clip[15] + clip[13];

; Normalize it
	movss	xmm0,dword ptr [rsi+16*2][4*0]
	mulss	xmm0,xmm0
	movss	xmm1,dword ptr [rsi+16*2][4*1]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	movss	xmm1,dword ptr [rsi+16*2][4*2]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	sqrtss	xmm0,xmm0
	movss	t,xmm0;t=(float)sqrt(frustum[2][0]*frustum[2][0]+frustum[2][1]*frustum[2][1]+frustum[2][2] * frustum[2][2] );
	movss	xmm0,dword ptr [rsi+16*2][4*0]
	divss	xmm0,t
	movss	dword ptr [rsi+16*2][4*0],xmm0;frustum[2][0] /= t;
	movss	xmm0,dword ptr [rsi+16*2][4*1]
	divss	xmm0,t
	movss	dword ptr [rsi+16*2][4*1],xmm0;frustum[2][1] /= t;
	movss	xmm0,dword ptr [rsi+16*2][4*2]
	divss	xmm0,t
	movss	dword ptr [rsi+16*2][4*2],xmm0;frustum[2][2] /= t;
	movss	xmm0,dword ptr [rsi+16*2][4*3]
	divss	xmm0,t
	movss	dword ptr [rsi+16*2][4*3],xmm0;frustum[2][3] /= t;


; Extract the TOP clipping plane
	movss	xmm0,clip[3*4]
	subss	xmm0,clip[1*4]
	movss   dword ptr [rsi+3*16][0*4],xmm0;frustum[3][0] = clip[ 3] - clip[ 1];
	movss	xmm0,clip[7*4]
	subss	xmm0,clip[5*4]
	movss   dword ptr [rsi+3*16][1*4],xmm0;frustum[3][1] = clip[ 7] - clip[ 5];
	movss	xmm0,clip[11*4]
	subss	xmm0,clip[9*4]
	movss   dword ptr [rsi+3*16][2*4],xmm0;frustum[3][2] = clip[11] - clip[ 9];
	movss	xmm0,clip[15*4]
	subss	xmm0,clip[13*4]
	movss   dword ptr [rsi+3*16][3*4],xmm0;frustum[3][3] = clip[15] - clip[13];

; Normalize it
	movss	xmm0,dword ptr [rsi+16*3][4*0]
	mulss	xmm0,xmm0
	movss	xmm1,dword ptr [rsi+16*3][4*1]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	movss	xmm1,dword ptr [rsi+16*3][4*2]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	sqrtss	xmm0,xmm0
	movss	t,xmm0;	t = (float) sqrt( frustum[3][0] * frustum[3][0] + frustum[3][1] * frustum[3][1] + frustum[3][2] * frustum[3][2] );
	movss	xmm0,dword ptr [rsi+16*3][4*0]
	divss	xmm0,t
	movss	dword ptr [rsi+16*3][4*0],xmm0;frustum[3][0] /= t;
	movss	xmm0,dword ptr [rsi+16*3][4*1]
	divss	xmm0,t
	movss	dword ptr [rsi+16*3][4*1],xmm0;frustum[3][1] /= t;
	movss	xmm0,dword ptr [rsi+16*3][4*2]
	divss	xmm0,t
	movss	dword ptr [rsi+16*3][4*2],xmm0;frustum[3][2] /= t;
	movss	xmm0,dword ptr [rsi+16*3][4*3]
	divss	xmm0,t
	movss	dword ptr [rsi+16*3][4*3],xmm0;frustum[3][3] /= t;


; Extract the FAR clipping plane
	movss	xmm0,clip[3*4]
	subss	xmm0,clip[2*4]
	movss   dword ptr [rsi+4*16][0*4],xmm0;frustum[4][0] = clip[ 3] - clip[ 2];
	movss	xmm0,clip[7*4]
	subss	xmm0,clip[6*4]
	movss   dword ptr [rsi+4*16][1*4],xmm0;frustum[4][1] = clip[ 7] - clip[ 6];
	movss	xmm0,clip[11*4]
	subss	xmm0,clip[10*4]
	movss   dword ptr [rsi+4*16][2*4],xmm0;frustum[4][2] = clip[11] - clip[10];
	movss	xmm0,clip[15*4]
	subss	xmm0,clip[14*4]
	movss   dword ptr [rsi+4*16][3*4],xmm0;frustum[4][3] = clip[15] - clip[14];

; Normalize it
	movss	xmm0,dword ptr [rsi+16*4][4*0]
	mulss	xmm0,xmm0
	movss	xmm1,dword ptr [rsi+16*4][4*1]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	movss	xmm1,dword ptr [rsi+16*4][4*2]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	sqrtss	xmm0,xmm0
	movss	t,xmm0;	t = (float) sqrt( frustum[4][0] * frustum[4][0] + frustum[4][1] * frustum[4][1] + frustum[4][2] * frustum[4][2] );
	movss	xmm0,dword ptr [rsi+16*4][4*0]
	divss	xmm0,t
	movss	dword ptr [rsi+16*4][4*0],xmm0;frustum[4][0] /= t;
	movss	xmm0,dword ptr [rsi+16*4][4*1]
	divss	xmm0,t
	movss	dword ptr [rsi+16*4][4*1],xmm0;frustum[4][1] /= t;
	movss	xmm0,dword ptr [rsi+16*4][4*2]
	divss	xmm0,t
	movss	dword ptr [rsi+16*4][4*2],xmm0;frustum[4][2] /= t;
	movss	xmm0,dword ptr [rsi+16*4][4*3]
	divss	xmm0,t
	movss	dword ptr [rsi+16*4][4*3],xmm0;frustum[4][3] /= t;


; Extract the NEAR clipping plane.  This is last on purpose (see pointinfrustum() for reason)
	movss	xmm0,clip[3*4]
	addss	xmm0,clip[2*4]
	movss   dword ptr [rsi+5*16][0*4],xmm0;frustum[5][0] = clip[ 3] + clip[ 2];
	movss	xmm0,clip[7*4]
	addss	xmm0,clip[6*4]
	movss   dword ptr [rsi+5*16][1*4],xmm0;frustum[5][1] = clip[ 7] + clip[ 6];
	movss	xmm0,clip[11*4]
	addss	xmm0,clip[10*4]
	movss   dword ptr [rsi+5*16][2*4],xmm0;frustum[5][2] = clip[11] + clip[10];
	movss	xmm0,clip[15*4]
	addss	xmm0,clip[14*4]
	movss   dword ptr [rsi+5*16][3*4],xmm0;frustum[5][3] = clip[15] + clip[14];

; Normalize it
	movss	xmm0,dword ptr [rsi+16*5][4*0]
	mulss	xmm0,xmm0
	movss	xmm1,dword ptr [rsi+16*5][4*1]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	movss	xmm1,dword ptr [rsi+16*5][4*2]
	mulss	xmm1,xmm1
	addss	xmm0,xmm1
	sqrtss	xmm0,xmm0
	movss	t,xmm0;	t = (float) sqrt( frustum[5][0] * frustum[5][0] + frustum[5][1] * frustum[5][1] + frustum[5][2] * frustum[5][2] );
	movss	xmm0,dword ptr [rsi+16*5][4*0]
	divss	xmm0,t
	movss	dword ptr [rsi+16*5][4*0],xmm0;frustum[5][0] /= t;
	movss	xmm0,dword ptr [rsi+16*5][4*1]
	divss	xmm0,t
	movss	dword ptr [rsi+16*5][4*1],xmm0;frustum[5][1] /= t;
	movss	xmm0,dword ptr [rsi+16*5][4*2]
	divss	xmm0,t
	movss	dword ptr [rsi+16*5][4*2],xmm0;frustum[5][2] /= t;
	movss	xmm0,dword ptr [rsi+16*5][4*3]
	divss	xmm0,t
	movss	dword ptr [rsi+16*5][4*3],xmm0;frustum[5][3] /= t;
	pop	rsi
	leave
	ret
ExtractFrustum endp
glPrint1 proc x:dword, y:dword, fmt:dword,params:VARARG; Where the Printing Happens
local	len:dword
local	buffer[256]:byte;   


	movss	x,xmm0
	movss	y,xmm1
	mov	fmt,r8d
	mov	params,r9d
	or	r8d,r8d;if (fmt == NULL);   
	jz	@f; 
	mov	r8d,r9d;constd45
	mov	edx,fmt
	lea	ecx,buffer
	invoke	vsprintf;(, fmt, ap); And Converts Symbols to Actual Numbers
	mov	len,eax
;	mov	ap,0
	invoke	glPushAttrib,GL_LIST_BIT; Pushes the Display List Bits
	mov	ecx,base
	sub	ecx,32
	invoke	glListBase; Sets the Base Character to 32
	movss	xmm1,y
	movss	xmm0,x
	invoke	glRasterPos2f; Move To Drawing Position
	lea	r8d,buffer
	invoke	glCallLists,len, GL_UNSIGNED_BYTE; Draws the display list text
	invoke	glPopAttrib; Pops the Display List Bits
@@:	leave
	ret
glPrint1 endp
glPrint proc x:dword, y:dword, fmt:dword,params:VARARG; Where the Printing Happens
local	len:dword
local	ap:qword
local	buffer[256]:byte;   


	movss	x,xmm0
	movss	y,xmm1
	mov	fmt,r8d
	mov	params,r9d
	or	r8d,r8d;if (fmt == NULL);   
	jz	@f; 
	mov	r8d,r9d
	mov	edx,fmt
	lea	ecx,buffer
	invoke	vsprintf;(, fmt, ap); And Converts Symbols to Actual Numbers
	mov	len,eax
	mov	ap,0
	invoke	glPushAttrib,GL_LIST_BIT; Pushes the Display List Bits
	mov	ecx,base
	sub	ecx,32
	invoke	glListBase; Sets the Base Character to 32
	movss	xmm1,y
	movss	xmm0,x
	invoke	glRasterPos2f; Move To Drawing Position
	lea	r8d,buffer
	invoke	glCallLists,len, GL_UNSIGNED_BYTE; Draws the display list text
	invoke	glPopAttrib; Pops the Display List Bits
@@:	leave
	ret
glPrint endp
BuildFont proc; Build Our Bitmap Font
local	font:HFONT; Windows Font ID

	invoke	glGenLists,96; Storage For 96 Characters
	mov	base,eax
	xor	edx,edx
	pushaddr aFontName
	push	rdx;FF_DONTCARE or DEFAULT_PITCH; Family And Pitch
	push	ANTIALIASED_QUALITY; Output Quality
	push	rdx;CLIP_DEFAULT_PRECIS; Clipping Precision
	push	OUT_TT_PRECIS; Output Precision
	push	rdx;ANSI_CHARSET; Character Set Identifier
	push	rdx; Strikeout
	push	rdx; Underline
	push	rdx; Italic
	push	FW_NORMAL; Font Weight
	sub	esp,20h
	mov	ecx,-12
	invoke	CreateFont,,,0,0; Orientation Angle
	mov	font,rax
	invoke	SelectObject,hDC, eax; Selects the Font We Created
	mov	r9d,base
	invoke	wglUseFontBitmapsA,hDC, 32, 96; Builds 96 Characters Starting At Character 32
	leave
	ret
BuildFont endp
;------------------------------------------------------------------------
numobjects	dd 200; Holds the Number Of Objects To Draw
windowwidth	dd ?; Holds the current Window (Screen) Width
windowheight	dd ?; Holds the current Window (Screen) Height
frame_		dd 0; Counter to be used in calculating FPS
timebase	dd 0; Used in calculating FPS
fps		dq 0; Holds the current FPS (Frames Per Second)
culling		db FALSE; Indicates If Frustum Culling Is On Or Not
grid		db TRUE; Indicates If Grid Should Be Drawn
mode		dd 1; Indicates Object Mode: 0=points 1=spheres 2=cubes
frustum		dd ?;6*4 dup (?); Holds the current Frustum Plane Equations
fov		dq 45.0; Holds the current FOV Value
xpos		dd 0; Holds the Camera's current X Position
zpos		dd 0; Holds the Camera's current Z Position
tilt		dd 0; Holds the Camera's current Tilt Angle
heading		dd 0; Holds the Camera's current heading
objects		dd ?;MAXOBJECTS*7 dup (?); Holds the Center X, Y, Z, Radius, and RGB For MAXOBJECTS Objects
LightAmbient	dd 3 dup(0.2), 1.0; Ambient Light Values
LightDiffuse	dd 4 dup(1.0); Diffuse Light Values
LightPosition	dd 3 dup(0), 1.0; Light Is At Origin
base		dd ?; Font base
;---------------------------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson#53: ",0
FileName	db "br_Rabbit3.cur",0
TitleName1	dd offset Title2,offset Title3,offset Title4
TitleName2	dd Title6,Title7
aFontName	db "Courier New",0; Font Name
Title0		db "FPS     : %0.1f",0
Title1		db "FOV     : %0.1f",0
Title2		db "Points  : %d",0
Title3		db "Spheres : %d",0
Title4		db "Cubes   : %d",0
Title5		db "Rendered: %d",0
Title6		db "Culling : Off",0
Title7		db "Culling : On",0
;-----------------------------
;float
const0_01 	dd 0.01
piover180	dd 0.0174532925199432957692369077;pi/180
const0_1 	dd 0.1
const0_25 	dd 0.25
const0_5	dd 0.5
const0_6	dd 0.6
const1		dd 1.0
const_2		dd -2.0
const10		dd 10.0
const20		dd 20.0
const30		dd 30.0
const40		dd 40.0
const50		dd 50.0
const100	dd 100.0
const360	dd 360.0
;double
constd0_1	dq 0.1
constd0_5	dq 0.5
constd1		dq 1.0
constd_1	dq -1.0
constd45	dq 45.0
constd50	dq 50.0
constd1000	dq 1000.0
end